function [perR, DstatUnKnown, TH0,chi2grejen] = bruteForceIterSolMultiVar2(Y, nbrOfPeriods, chi2limit,silent)
%THEALGORITHM Summary of this function goes here
%   Detailed explanation goes here
perR=zeros(nbrOfPeriods,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Create matrix T where each column corresponds to a periodicity and offset
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
periods = 1:nbrOfPeriods;
T = zeros(length(Y),sum(periods));
%T(:,1) = ones(length(Y),1);
pos=2;
refPer=[1];
for iii = 3:length(periods)
    I = eye(periods(iii));
    IM = repmat(I,length(Y),1);
    T(:,pos:pos+periods(iii)-1) = IM(1:length(Y),:);
    pos = pos + periods(iii);
    refPer=[refPer iii*ones(1,iii)];
end
[~,Tp]=size(T);

%%????????
for counter=1:Tp
    Itmp=find(T(:,counter));
    SumY(counter)=sum(Y(Itmp)); %Counting number of 1 in y
    SumT(counter)=sum(T(:,counter)); % Counting number of 1 in T
end
lengthy=length(Y);
sumy=sum(Y);
%%????????




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Estimate distribution for H1, adding one set of periodic indixes for each
% iteration
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
itermax=5;
TH0=zeros(lengthy,1);
delta=1e-88;
for iter=1:itermax
    for counter=1:Tp
        
        % Complelement set of periodic indices (H0)
        
      %  LLH0(counter)=likelihoodMultiVar(Y,TH0)*refPer(counter);
        LLH0(counter)=likelihoodMultiVar2(Y,TH0,0);
        %         PpH0=sum(y(IpCompH0))/length(y(IpCompH0));
        %         PnH0=max((length(y(IpH0))-sum(y(IpH0)))/length(y(IpCompH0)),0.000001);
        %         LLH0(counter)=sum(y(IpCompH0))*log(PpH0+delta)+(length(y(IpCompH0))-...
        %             sum(y(IpCompH0)))*log(1-PpH0+delta)+...
        %             sum(y(IpH0))*log(1-PnH0+delta)+(length(y(IpH0))-sum(y(IpH0)))*log(PnH0+delta);
        
        % Periodic indices set (H1)
        TH1=T(:,counter);
        %         IpH1=find(TH1);
        %         IpCompH1=find(TH1==0);
        %         if isempty(IpCompH1)~=1
        %             PpH1=sum(Y(IpCompH1))/length(Y(IpCompH1));
        %         else
        %             PpH1=delta;
        %         end
        %         PnH1=(length(Y(IpH1))-sum(Y(IpH1)))/length(Y(IpH1));
        
        
        %         if PnPrior~=0
        %             PnH1=min(PnH1,PnPrior);
        %         end
        %pensave 
       % LLH1(counter)=likelihoodMultiVar(Y,[TH0 TH1])*refPer(counter)-6*refPer(counter)*log(floor(lengthy/refPer(counter)))/2;
        LLH1(counter)=likelihoodMultiVar2(Y,[TH0 TH1],1);
        %LLH1(counter)=sum(y(IpCompH1))*log(PpH1+delta)+(length(y(IpCompH1))-...
        %   sum(y(IpCompH1)))*log(1-PpH1+delta)+...
        %   sum(y(IpH1))*log(1-PnH1+delta)+(length(y(IpH1))-sum(y(IpH1)))*log(PnH1+delta);%+...
    end
    
    Indcounter=1;
    DstatUnKnown=-inf*ones(nbrOfPeriods,nbrOfPeriods);
    ScaleM=ones(nbrOfPeriods,nbrOfPeriods);
    for j = 1:nbrOfPeriods
        for i = 1:j
            %Results(i,j)=SumY(Indcounter)/SumT(Indcounter);
            DstatUnKnown(i,j)=-2*(LLH0(Indcounter)-LLH1(Indcounter));
            %            MeshPp(i,j)=PpH1(counter);
            %            MeshPn(i,j)=PnH1(counter);
            Indcounter=Indcounter+1;
            ScaleM(i,j)=j;
        end
    end
 %DstatUnKnown(1:2,1:2)=-inf*ones(2,2);
    
    [~,Idstat] = max(DstatUnKnown(:));
    [tmpPhase,tmpPer] = ind2sub(size(DstatUnKnown),Idstat);
    [~,ImaxH1]=max(-2*(LLH0-LLH1));

    

    if max(-2*(LLH0-LLH1)) > chi2limit;
        chi2grejen=max(-2*(LLH0-LLH1));
    TH0=[TH0 T(:,ImaxH1)];
    %T(:,ImaxH1)=T(:,1); % Overwrite the chosen periodicity with zeros
    perR(iter)=refPer(ImaxH1);
    %     for kk=ImaxH1+1:Tp
    %         if min(T(:,ImaxH1)-T(:,kk))==0
    %             T(:,kk)=T(:,1);
    %         end
    %
    %     end
    Tsave=T(:,ImaxH1);
    for kk=1:Tp
        T(:,kk)=T(:,kk)-Tsave;
    end
    T(T<0)=0;
    
    T(:,ImaxH1)=T(:,1);
    else
        return;
    end
    if (iter==1 || iter==2)&& ~silent
        figure(iter)
        [X,YY] = meshgrid(1:nbrOfPeriods,1:nbrOfPeriods);
        mesh(X,YY,DstatUnKnown)
        title(num2str(perR(iter)))
        title(['Dstat, iter: ' num2str(iter)])
    end
end
end
%[X,Y] = meshgrid(1:nbrOfPeriods,1:nbrOfPeriods)
%mesh(X,Y,DstatUnKnown)


