function L=likelihoodMultiVar2(Y,TH0,Type)

[N, M]=size(TH0);
I=sum(TH0,2);
I(I>1)=1;
Icomp=find(ones(N,1)-I);

for i=1:M
    Itmp=find(TH0(:,i));
    Ytmp=Y(:,Itmp);
    L(i)=likelihood(Ytmp,Type);
end
 L(M+1)=likelihood(Y(:,Icomp),0);
L=sum(L);

end
function L=likelihood(Y,Type)
if isempty(Y)==0
   lengthY= length(Y);
    sumy1=sum(Y(1,:));
    if Type==0
    P1H0=sumy1/lengthY+eps;
    P0H0=1-P1H0+eps;
    else
        P1H0=max(0.5,sumy1/lengthY);
        P0H0=1-P1H0+eps;
    end
    %binfact=gammaln(lengthY+1)-gammaln(sumy1+1)-gammaln(sumy2+1)-gammaln(sumy3+1)-gammaln(sumy4+1);
    binfact=0;
    L=binfact+sumy1*log(P1H0)+(length(Y)-sumy1)*log(P0H0);
    %L=sum(Y(1,:))*log(PAH0)+sum(Y(2,:))*log(PCH0)+sum(Y(3,:))*log(PGH0)...
     %   +sum(Y(4,:))*log(PTH0);
else
    L=0;
end
end