function [c, fopt] = logregsolCCD(T,Y,lambda,c,cweight)
itermax=20;
[N,M]=size(T);
MaxNoNewton=3;
lambda=lambda*cweight;
lambda=[0; lambda];
Y=Y';
j=0;
cold=ones(size(c));
%for j =1:itermax
while norm(cold-c)> 10^(-5) && j<1000
        j=j+1;
    cold=c;
    %fsteps(j)=-Y'*T*c+lambda'*abs(c)+sum(log(1+exp(T*c)));
    for i=1:M
        xkTHi=Y'*T(:,i);
        hi=T(:,i);
        ctmp=c(i);
        c(i)=0;
        fnoll=-Y'*T*c+lambda'*abs(c)+sum(log(1+exp(T*c)));
        
        plotfnoll=0;
        if plotfnoll==1
            cnoll=linspace(-5,5,500);
            for drawiter=1:500
                c(i)=cnoll(drawiter);
                plotfnoll(drawiter)=-Y'*T*c+lambda'*abs(c)+sum(log(1+exp(T*c)));
            end
            plot(cnoll,plotfnoll)
        end
        
        
        c(i)=ctmp;
        for NewtonStep=1:MaxNoNewton
            Tc=T*c;
            expmTc=exp(-Tc);
            fprime=-xkTHi+lambda(i)*sign(c(i))+hi'*(1./(1+expmTc));
            fbis=hi'*(expmTc./(1+expmTc).^2);
            c(i)=c(i)-fprime/fbis;
            if isnan(c(i))
                c(i)=0;
            end
%             if i>1
%                 if c(i)<0
%                     c(i)=0;
%                 end
%             end
   
           
        end
        fnewt=-Y'*Tc+lambda'*abs(c)+sum(log(1+exp(Tc)));
        if i>1
            if fnoll<fnewt || c(i)<0
                c(i)=0;
            end
        end
        if plotfnoll==1
        hold on;
        plot(c(i),min(fnewt,fnoll),'r*')
        end
    end
    if plotfnoll==1
    plot(c)
    title(num2str(j))
    hold on
    cdiff(j)=norm(c-cold);
    end
end
fopt=min(fnewt,fnoll);
if plotfnoll==1
figure
semilogy(cdiff)
end
end