function [ seq ] = noiseAdderBinary(seq, Pp, Pn)
%NOISEADDER Summary of this function goes here
%   seq - The sequence
%   Pp  - Probability of changing 0 to 1
%   Np  - Probability of changing 1 to 0
for i=1:length(seq)
    if seq(i) == 1
        if rand < Pn
            seq(i) = 0;
        end
    else
        if rand < Pp
            seq(i) = 1;
        end
    end
    
end

