function [perR, LrR, SizeOut] = LogRegSolReweightCCD(Y, nbrOfPeriods, lambda,silent,p1,p2)
perR=zeros(nbrOfPeriods,1);
LrR=perR;
RatioOnes=LrR;
nbrOfSymbols = size(Y,1);
for ii = 1:nbrOfSymbols
    clear x y T index2 index ind
    y = Y(ii,:);
    periods = 1:nbrOfPeriods;
    T = zeros(length(y),sum(periods)-2);
    T(:,1) = ones(length(y),1);
    pos=2;
    fuskvektorn=[1];
    for i=3:nbrOfPeriods
        for j=1:i;
            fuskvektorn=[fuskvektorn i];
        end
    end
    for iii = 3:length(periods)
        I = eye(periods(iii));
        IM = repmat(I,length(y),1);
        T(:,pos:pos+periods(iii)-1) = IM(1:length(y),:);
        pos = pos + periods(iii);
    end
    [~,Tp]=size(T);
    for counter=1:Tp
        Itmp=find(T(:,counter));
        SumY(counter)=sum(Y(Itmp)); %Counting number of 1 in y
        SumT(counter)=sum(T(:,counter)); % Counting number of 1 in T
    end
    lengthy=length(y);
    sumy=sum(y);
    %Tnorm=norms(T,2,1);
    %T=T./repmat(Tnorm,length(y),1);
    counter=1;
    
end
%lambda=0.3;

% Solve problem
%
% minimize  -(sum_(y_i=1) ui)*a - b + sum log (1+exp(a*ui+b)

%U = [ones(m,1) u];
%xweight=(log(5+fuskvektorn(2:end))/mean(log(5+fuskvektorn(2:end))))'.*ones(Tp-1,1);
xweight=ones(Tp-1,1);
% figure(1)
% plot(fuskvektorn(2:end),xweight)
x=zeros(Tp,1);
timeCCD=0;
timeCVX=0;
for i=1:10
    
    % It=eye(Tp);
    % It(:,1)=-1;
    % It=It(2:end,:);
    %tic
    [x,fopt]=logregsolCCD(T,y,lambda,x,xweight);
%     plotta=1;
%     if plotta==1
%         figure
%         plot(fuskvektorn, x,'*')
%         title(['iter: ' num2str(i)])
%     end
    timeCCD=timeCCD+toc;
    cvxcompare=0;
    if cvxcompare==1
        tic
        xtmp=x;
        cvx_clear
        cvx_expert = true;
        cvx_quiet('true')
        cvx_precision('high')
        cvx_solver('SeDuMi')
        cvx_begin
        variables x(Tp)
        minimize(-y*T*x+sum(log_sum_exp([zeros(1,lengthy); x'*T']))+lambda*norm(xweight.*x(2:end),1))
        subject to
        %log(0.5)*ones(size(y')) <= T(:,2:end)*x(2:end)-log_sum_exp([zeros(1,lengthy); x(2:end)'*T(:,2:end)'])'
        %log(0.5)*ones(size(x(2:end)))<= x(1)*ones(size(x(2:end)))+x(2:end)-log(1+x(1)*ones(size(x(2:end)))+x(2:end))
        %log(0.5)*ones(size(x(2:end))) <= (It*x-log_sum_exp([zeros(1,length(x(2:end))); x'*It'])')
        % x(1)<=0;
        %x(1)<=sum(x(2:end));
        zeros(size(x(2:end))) <= x(2:end);
        %ones(size(y'))*log(0.95/(1-0.95))<=T(:,2:end)*(x(2:end));
        %ones(size(y'))*x(1)<=T(:,2:end)*(x(2:end))
        % zeros(size(y'))*x(1)<=T(:,2:end)*(x(2:end))
        %log(0.5)*ones(size(y')) <= T()*x-log_sum_exp([zeros(1,lengthy); x'*T'])'
        %maximize(y'*T*x-sum(log_sum_exp([zeros(1,m); x'*T'])))
        %log(0.25/(1-0.25))<=x(1)
        cvx_end
        display(['norm diff variable cvx vs ccd ' num2str(norm(x-xtmp))])
        display(['ccdopt-cvxopt = ' num2str(fopt(end)-cvx_optval)])
        figure
        semilogy(abs(fopt-cvx_optval))
        timeCVX=timeCVX+toc;
        display(['time CCD: ' num2str(timeCCD)])
        display(['time CVX: ' num2str(timeCVX)])
        figure
        plot(x)
        hold on
        plot(xtmp,'r')
        legend('CVX','CCD')
    end
  
   if silent==0  && i ==10
    plot(fuskvektorn,x,'*')
    title(['p1: ' num2str(p1) ' p2: ' num2str(p2)])
    penn=exp(T*x)./(1+exp(T*x));
    pennminuettan=exp(T(:,2:end)*x(2:end))./(1+exp(T(:,2:end)*x(2:end)));
    [penn(1:10) pennminuettan(1:10) y(1:10)' x(1:10)];
   end
   [Y,I] = sort(abs(x(2:end)),'descend');
    fuskvektorntemp=fuskvektorn(2:end);
    perR=[fuskvektorntemp(I(1:5))];
    SizeOut=[Y(1:10)];
    %xweight=(log(5+fuskvektorn(2:end))/mean(log(5+fuskvektorn(2:end))))'.*1./(abs(x(2:end))+0.1);
    xweight=1./(abs(x(2:end))+0.1);
    
end


end
