function [st, pA] = setPeriodicityBinary(st, pA)
%SETPERIODICITY Set the periodicity of the symbols
%   Input:Untitled event
%         st = the sequence of symbols
%         pA = the periodicity of A
%   If pX is set to 0 the periodicity is set to a random number between 4
%   and 25. If pX is less than 0 no periodicity is added to the sequence.
%% 2012-10-12 Johan Sw?rd
if pA == 0
    pA=round(22*rand+4);
end
pA=sort(pA,'ascend');
counter=[0,0];
perCheck =0;
if pA>0
    while counter(1)==counter(2) || perCheck==0
        st=zeros(size(st));
    for i = 1:length(pA)
        phase(i)=randi(pA(i));
        a=[1,2;3,4;5,6];
        if sum(pA==[4,6]) && i==2
            phase(2)=a(randi(3),mod(phase(1),2)+1);
        end
        for k = phase(i):pA(i):length(st)
            st(k) = 1;
        end
        counter(i)=sum(st);
    end
    perCheck=testper(st,pA); %kollar om b?da finns, counter(1)==counter(2) kollar om det bara finns en per.
    end  

end
end

function TrueFalse=testper(st, pA)
    pA = sort(pA,'ascend');
    %pA can only have 2 values
    periods = 1:max(pA);
    T = zeros(length(st),sum(max(pA)));
    T(:,1) = ones(length(st),1);
    pos=2;
    for iii = 2:length(periods)
        I = eye(periods(iii));
        IM = repmat(I,length(st),1);
        T(:,pos:pos+periods(iii)-1) = IM(1:length(st),:);
        pos = pos + periods(iii);
    end
    [~,Tp]=size(T);
    for counter2=1:Tp
        Itmp=find(T(:,counter2));
        SumY(counter2)=sum(st(Itmp)); %Counting number of 1 in y
        SumT(counter2)=sum(T(:,counter2)); % Counting number of 1 in T
    end
      test=SumY-SumT;
      antaliIj=ceil(pA(2)/pA(1))-1;
      Iremove=[];
    for j=2:antaliIj
       Iremove = [Iremove sum(1:(j*pA(1)-1))+1:sum(1:j*pA(1))]; 
    end
    test(Iremove)=-1;
  
    Itest=find(test==0);
    Ireject=[1:sum(1:(pA(1)-1)) sum(1:pA(1))+1:sum(1:pA(2)-1)];
  
    
        
    for i =1:length(Itest)
       A(i)= sum(Itest(i)==Ireject);       
    end
    Ireject;
    Itest;
    if sum(A)~=0
       TrueFalse=0; 
    else
        TrueFalse=1;
    end
end


